#include "stdafx.h"

double GetCounterValue(const wchar_t * fullCounterPath)
{
	HQUERY hquery;
	PDH_STATUS status;
	status=PdhOpenQuery(NULL,NULL,&hquery);
	if(status!=ERROR_SUCCESS)
	{
		return -1;
	}
	HCOUNTER counter=NULL;
	status=PdhAddCounter(hquery, fullCounterPath, NULL, &counter);
	if(status!=ERROR_SUCCESS)
	{
		return -1;
	}
	status=PdhCollectQueryData(hquery);
	if(status!=ERROR_SUCCESS)
	{
		return -1;
	}
	PDH_FMT_COUNTERVALUE counterValue;
	status=PdhGetFormattedCounterValue(counter,PDH_FMT_DOUBLE,NULL,&counterValue);
	if(status!=ERROR_SUCCESS)
	{
		return -1;
	}
	status=PdhCloseQuery(hquery);
	if(status!=ERROR_SUCCESS)
	{
		return -1;
	}
	return counterValue.doubleValue;
}

double GetCounterValueWithSleep(const wchar_t * fullCounterPath,int idleTime)
{
	HQUERY hquery;
	PDH_STATUS status;
	status=PdhOpenQuery(NULL,NULL,&hquery);
	if(status!=ERROR_SUCCESS)
	{
		return -1;
	}
	HCOUNTER counter=NULL;
	status=PdhAddCounter(hquery, fullCounterPath, NULL, &counter);
	if(status!=ERROR_SUCCESS)
	{
		return -1;
	}
	status=PdhCollectQueryData(hquery);
	if(status!=ERROR_SUCCESS)
	{
		return -1;
	}

	Sleep(idleTime);

	status=PdhCollectQueryData(hquery);
	if(status!=ERROR_SUCCESS)
	{
		return -1;
	}
	PDH_FMT_COUNTERVALUE counterValue;
	status=PdhGetFormattedCounterValue(counter,PDH_FMT_DOUBLE,NULL,&counterValue);
	if(status!=ERROR_SUCCESS)
	{
		return -1;
	}
	status=PdhCloseQuery(hquery);
	if(status!=ERROR_SUCCESS)
	{
		return -1;
	}
	return counterValue.doubleValue;
}

list<wstring> GetInstanceName(const wchar_t * objectName)
{
	list<wstring> ret;
	wchar_t * counterListBuffer = NULL;
	wchar_t * instanceListBuffer = NULL;
	DWORD dwCounterListSize = 0;

	DWORD dwInstanceListSize = 0;  
	BOOL pass =FALSE;
	PDH_STATUS status = PdhEnumObjectItems(NULL,NULL,objectName,counterListBuffer,&dwCounterListSize,instanceListBuffer,&dwInstanceListSize,PERF_DETAIL_WIZARD, 0); 

	if(status == PDH_MORE_DATA)
	{
		counterListBuffer=(wchar_t *)malloc((dwCounterListSize*sizeof(wchar_t)));
		instanceListBuffer=(wchar_t *)malloc((dwInstanceListSize*sizeof(wchar_t)));
		status= PdhEnumObjectItems(NULL,NULL,objectName,counterListBuffer,&dwCounterListSize,instanceListBuffer,&dwInstanceListSize,PERF_DETAIL_WIZARD,0); 
		if(status == ERROR_SUCCESS) 
		{
			wchar_t * instance = instanceListBuffer;
			for(; *instance != 0; instance += lstrlen(instance) + 1) 
			{
				ret.push_back(wstring(instance));
			}
		}
	}
	if(counterListBuffer != NULL) 
	{
		free(counterListBuffer);
	}
	if(instanceListBuffer != NULL) 
	{
		free(instanceListBuffer);
	}
	return ret;
}

list<wstring> GetCounterList(const wchar_t * objectName)
{
	list<wstring> ret;
	wchar_t * counterListBuffer = NULL;
	wchar_t * instanceListBuffer = NULL;
	DWORD dwCounterListSize = 0;

	DWORD dwInstanceListSize = 0;  
	BOOL pass =FALSE;
	PDH_STATUS status = PdhEnumObjectItems(NULL,NULL,objectName,counterListBuffer,&dwCounterListSize,instanceListBuffer,&dwInstanceListSize,PERF_DETAIL_WIZARD, 0); 

	if(status == PDH_MORE_DATA)
	{
		counterListBuffer=(wchar_t *)malloc((dwCounterListSize*sizeof(wchar_t)));
		instanceListBuffer=(wchar_t *)malloc((dwInstanceListSize*sizeof(wchar_t)));
		status= PdhEnumObjectItems(NULL,NULL,objectName,counterListBuffer,&dwCounterListSize,instanceListBuffer,&dwInstanceListSize,PERF_DETAIL_WIZARD,0); 
		if(status == ERROR_SUCCESS) 
		{
			wchar_t * counterList = counterListBuffer;
			for(; *counterList != 0; counterList += lstrlen(counterList) + 1) 
			{
				ret.push_back(wstring(counterList));
			}
		}
	}
	if(counterListBuffer != NULL) 
	{
		free(counterListBuffer);
	}
	if(instanceListBuffer != NULL) 
	{
		free(instanceListBuffer);
	}
	return ret;
}